{ VBMan ActiveX Control for rs-232c binary Tv }
{ Copyright 1997, TechKnowledge all rights reserved }
{ }
{ Q|[g̃p\RŃNXEP[uڑŊmFĂ }
unit binary;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, VBMCOM32Lib_TLB;

type
  TForm1 = class(TForm)
    btnSendBin: TButton;
    btnRecvBin: TButton;
    VBMCom1: TVBMCom;
    VBMCom2: TVBMCom;
    procedure btnSendBinClick(Sender: TObject);
    procedure btnRecvBinClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OnError(Sender: TObject; MajorErrorCode: Smallint;
      MinorErrorCode: Integer);
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses variants;

procedure TForm1.btnSendBinClick(Sender: TObject);
var rc: smallint;
    s: OleVariant;
begin
  s := VarArrayCreate([0,7],varByte);
  s[0] := $80;
  s[1] := $81;
  s[2] := $82;
  s[3] := $83;
  s[4] := $84;
  s[5] := $85;
  s[6] := $86;
  s[7] := $87;
  rc := vbmcom1.SendBinaryBytes(s);
end;

procedure TForm1.btnRecvBinClick(Sender: TObject);
var
 rc: smallint;
 r: OleVariant;
 i: smallint;
begin
  r := VarArrayCreate([0,7],varByte);
  rc := VBMCom2.RecvBinaryBytes(r,8);
  If rc <> 0 then
    begin
     Application.MessageBox('G[','',IDOK);
    end
  else
    begin
    { recvBufferQ }
    for i := 0 to 7 do
    begin
      r[i] := VBMCom2.RecvBuffer[i];
      writeln(r[i]);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var rc: smallint;
begin
VBMCom1.VcDebugTrace := True;        { Trace On }
VBMcom1.VcDeviceName := 0;           { COM1 }
rc := VBMCom1.OpenComm;
if rc <> 0 then
  begin
    Application.MessageBox('COM1|[gJ܂','G[',IDOK)
  end;

VBMCom2.VcDebugTrace := True;        { Trace On }
VBMCom2.VcDeviceName := 1;           { COM2 }
rc := VBMCom2.OpenComm;
if rc <> 0 then
  begin
    Application.MessageBox('COM2|[gJ܂','G[',IDOK)
  end;
end;

procedure TForm1.OnError(Sender: TObject; MajorErrorCode: Smallint;
  MinorErrorCode: Integer);
var
    strMajorErr:String;
    strMinorErr:String;
    Caption: PChar;
    Msg:array [0..32] of Char;
    tmpStr:String;
begin
 { ʐMG[\ }
 Str( MajorErrorCode, strMajorErr);
 Str( MinorErrorCode, strMinorErr);
 tmpStr := 'ʐMG[' + strMajorErr + ' : ' + strMinorErr;
 Caption := 'ʐMG[';
 StrPCopy(Msg,tmpStr);
 Application.MessageBox(Msg,Caption,IDOK);
end;

procedure TForm1.OnClose(Sender: TObject; var Action: TCloseAction);
var rc:integer;
begin
{rc := VBMCom1.CloseComm;
rc := VBMCom2.CloseComm;}
end;

end.
